<!--
@license
Copyright (c) 2016 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<link rel="import" href="../bower_components/polymer/polymer-element.html">
<link rel="import" href="shared-styles.html">
<link rel="import" href="../bower_components/paper-input/paper-input.html">
<link rel="import" href="../bower_components/paper-button/paper-button.html">
<link rel="import" href="../bower_components/iron-form/iron-form.html">
<link rel="import" href="../bower_components/paper-dropdown-menu/paper-dropdown-menu.html">
<link rel="import" href="../bower_components/paper-item/paper-item.html">
<link rel="import" href="../bower_components/paper-listbox/paper-listbox.html">
<link rel="import" href="../bower_components/neon-animation/web-animations.html">

<dom-module id="fund-transfer">
  <template>
    <style include="shared-styles">
      :host {
        display: block;

        padding: 10px;
      }
      .card {
           width: 40%;
            margin: 30px auto;
      }
    paper-button.indigo {
    background-color: var(--paper-indigo-500);
    color: white;
    --paper-button-raised-keyboard-focus: {
      background-color: var(--paper-pink-a200) !important;
      color: white !important;
    };
  }
  
   .card h1{    margin: 0px;
    padding: 0px 0px 11px 0px;    
    border-bottom: 1px solid #FF6D00;}

     paper-dropdown-menu, paper-listbox {
    width: 100%;
  }
  paper-dropdown-menu {
    margin: auto;
    display: block;
  } 
    </style>
    <iron-ajax id="submitFundTransfer"
            method="post"
            handle-as="json"
            on-response="_handleResponse"
            content-type="application/json"
            debounce-duration="300">
        </iron-ajax>
    <div class="card">
       <p style="text-align:right">Welcome <strong>[[data.userName]]</strong>
        <paper-button class="pink" style="color:#dd2c00" on-tap="_logout">Logout</paper-button> 
      </p>
      <h1 style="margin-bottom:20px">Fund Transfer</h1>
     <iron-form id="fondTransfer">
      <form method="post" name="fondTransfer" >
          <paper-input label="Sender Account" name="sendingUserId" value="{{data.userName}}" style="color:#000" readonly></paper-input>
          
          <paper-dropdown-menu label="Reciever Account" value="{{transaction.reciverAccount}}">
         <paper-listbox slot="dropdown-content"  selected="0">
           <paper-item value="default" name="type">Select Reciever Account</paper-item>
           <paper-item value="suresh" name="suresh">Suresh</paper-item>
           <paper-item value="User2" name="User2">User2</paper-item>
        </paper-listbox>
    </paper-dropdown-menu>

          <!--<paper-input label="Reciever Account" name="recievingUserId" value="{{transaction.recievingUserId}}"  required 
          auto-validate 
          error-message="Reciever Account is required!"></paper-input>-->
          
         <paper-input label="Transfer Amount" name="amount" value="{{transaction.amount}}"  required 
          auto-validate 
          error-message="Transfer amount is required" allowed-pattern="[0-9.]" char-counter maxlength="8"></paper-input>
          <paper-input label="Transfer Description" name="description" value="{{transaction.description}}"  required 
          auto-validate 
          error-message="Description is required !" allowed-pattern="[a-zA-Z]" char-counter maxlength="40"></paper-input>

          <div style="margin-top:30px;">   
          <paper-button raised class="indigo" on-tap="_saveTrasactions">Submit</paper-button>
          <paper-button raised class="indigo" on-tap="_reset">Reset</paper-button>
          <paper-button raised class="indigo" on-tap="_goToTransaction">Go To Transaction</paper-button>
          </div>
        </form>
      </iron-form>
    </div>
  </template>

  <script>
    class FundTransfer extends Polymer.Element {
      static get is() { return 'fund-transfer'; }
      static get properties() {
        return {
          transaction: {
            type: Object,
            notify: true,
            value: () => {
              return {
                userId:'',
                reciverAccount: '',
                amount: '',
                description: '',
              };
            },
          }
        };
      }
      constructor(){
        super();
         this.data=JSON.parse(localStorage.getItem('transactionData'));
      }

      _saveTrasactions(){
                this.params = {
                    "userId":this.data.userName,
                    "senderId": this.transaction.reciverAccount,
                    "description": this.transaction.description,
                    "amount": this.transaction.amount
                };
                var ajax = this.$.submitFundTransfer;
                ajax.url = "http://10.117.189.59:8080/payment/addPayment";
                ajax.body = this.params;
                ajax.generateRequest();
      }
      _handleResponse(){
        
      }
      _reset(){
        this.set('transaction');
      }
      _goToTransaction(){
        window.location.href="/transactions"
      }
      _logout(){
        window.location.href="/login";
        localStorage.removeItem(transactionData);

      }
    }

    window.customElements.define(FundTransfer.is, FundTransfer);
  </script>
</dom-module>
